<div>
  <h1 style="text-align:center">
    welcome to {{ title }}!
  </h1>
  <mat-card class="message-card">
    <mat-card-header>
      <div mat-card-avatar class="example-header-image">
        <mat-icon aria-label="send icon">mail</mat-icon>
      </div>
      <mat-card-title>messages</mat-card-title>
      <mat-card-subtitle>send messages to other components through DOM message bus.</mat-card-subtitle>
    </mat-card-header>
    <mat-divider></mat-divider>
    <h4>received messages</h4>
    <mat-card-content class="table-container">
      <mat-table [dataSource]="dataSource">
        <ng-container matColumnDef="sender">
          <mat-header-cell *matHeaderCellDef> sender</mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.sender}} </mat-cell>
        </ng-container>
        <ng-container matColumnDef="receiver">
          <mat-header-cell *matHeaderCellDef> receiver</mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.receiver}} </mat-cell>
        </ng-container>
        <ng-container matColumnDef="message">
          <mat-header-cell *matHeaderCellDef> message</mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.message}} </mat-cell>
        </ng-container>
        <ng-container matColumnDef="timestamp">
          <mat-header-cell *matHeaderCellDef> timestamp</mat-header-cell>
          <mat-cell *matCellDef="let element"> {{element.timestamp | date:'medium'}} </mat-cell>
        </ng-container>
        <mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></mat-header-row>
        <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
      </mat-table>
    </mat-card-content>
    <mat-divider></mat-divider>
    <h4>send a message</h4>
    <mat-card-actions>
      <mat-form-field>
        <input #targetElement matInput placeholder="target">
      </mat-form-field>
      <mat-form-field>
        <input #messageToSend matInput placeholder="message">
      </mat-form-field>
      <button mat-stroked-button color="primary" (click)="sendMessage(targetElement.value, messageToSend.value)">
        send
        <mat-icon aria-label="send icon">send</mat-icon>
      </button>
    </mat-card-actions>
  </mat-card>
</div>
